; Assembly Source File
; Created 22/03/2005, 12:07:20
	include "tios.h"
	include "conflib_asm.h" 
	include "utsrlib_asm.h"
; include "kernel.h"
    xdef   _main
    xdef   _ti89
    xdef   _ti92plus
    xdef   _v200
    xdef   _ti89ti
 
_main:
 move.w  #ROM_VERSION,d0; ams 2.06+ demande
 and.w   #$0FFF,d0
 cmp.w   #$0206,d0
 blt     \exit
 cmp.b   #1,HW_VERSION;hw 1
 ble     \exit

 move.w  #UTSR_AUTHORIZE_DLG,-(a7)
 pea     data_tsr(pc)
 move.w  #1,-(a7);nombre de fonctions dans le TSR !
 move.l  #_tsr_end-_tsr_beginning,-(a7)
 pea     _tsr_beginning(pc)
 jsr     utsrlib::utsr_install
 lea     16(a7),a7

 move.l  200,a0
 move.l  $5f5*4(a0),a0;ClockOn 
 jsr     (a0)
 rts
\exit:
 moveq   #1,d0
 move.l  d0,-(a7)
 pea     error_str(pc)
 pea     _tsr_beginning(pc)
 jsr     tios::DlgMessage
 lea     12(a7),a7
 rts

data_tsr:
 dc.w     UTSR_AUTOINT_5,_tsr_autoint5-_tsr_beginning

_tsr_beginning:
 dc.b    'AClock',0,0
_tsr_id:
 dc.w    0
_tsr_autoint5:
 jsr     _ROM_CALL_5F8;Timer_Start
 cmp.l   _clock(pc),d0
 bne     \continue;l'horloge n'a pas eu le temps d'avancer 
 rts
\continue:
; move.l  #tios::ST_eraseHelp,a0
; move.w  4(a0),a0
; btst.b  #7,(a0);la barre n'a pas  tre redessine
; bne     \exit

 move.l  d3,-(a7)
 move.l  d0,d3
 clr.w   -(a7)
 jsr     tios::FontSetSys
 move.w  d0,(a7)
 move.l  d3,d1
 move.l  #86400,d0
 jsr     tios::_mu32u32;d1 mod d0 -> d1
 moveq   #60,d0
 jsr     tios::_du32u32;d1 / d0 -> d1
;ici d1 = 60 * h + min
 divu.w  #60,d1
 swap    d1  
 move.l  d1,-(a7)
 pea     _string(pc)
 pea     _buffer(pc)
 jsr     tios::sprintf
 move.w  #4,-(a7)
 pea     _buffer(pc)
 move.w  #Y,-(a7)
 move.w  #X,-(a7)
 jsr     tios::DrawStr
 lea     22(a7),a7
 jsr     tios::FontSetSys
 addq.l  #2,a7
 lea     _clock(pc),a0
 move.l  d3,(a0)
 move.l  (a7)+,d3
\exit:
 rts
_clock:
 ds.l    1
_buffer:
 ds.b    20
_string:
 dc.b   '%02d:%02d',0
_tsr_end:
error_str:
 dc.b   'HW 2+ and AMS 2.06+ needed',0
 even
 
 EXTRA_RAM_TABLE
 EXTRA_RAM_ADDR 0000,X,141,201
 EXTRA_RAM_ADDR 0001,Y,95,123
